# Travail Pratique 001 : polynômes et Reed-Solomon (modulo un nombre premier)
Cours : ISC_122 – 2021-2022

Groupe : Gawen ACKERMANN, Florian BURGENER, Quentin FASLER, Dario GENGA

## Structure du projet

Afin de réaliser ce travail pratique, nous avons créé une classe nommée `Polynomial`, contenant des méthodes permettant
d'ajouter, multiplier et d'appliquer un modulo sur un polynôme. Cette classe peut également afficher le 
polynôme dans la console et obtenir y en passant x par le polynôme (faire P(x) = y).

En plus de cette classe, le programme contient les fonctions suivantes :

- `get_bezout_coefficients(a, b)` : calcule les coefficients de Bézout pour les valeurs `a` et `b` ;
- `modular_inverse(a, n)` : calcule l'inverse modulaire de `a` dans les modulos `n` ;
- `compute_lagrange_polynomial(points, prime_number)` : calcule le polynôme de Lagrange dans un modulo `prime_number` ;
- `reed_solomon(...)` : corrige le message en utilisant la définition du code de Reed-Solomon.


## Explication de notre algorithme pour corriger le message

Afin de corriger le message, nous utilisons la fonction `reed_solomon` qui fonctionne de la manière suivante :

1. On parcourt toutes les combinaisons (de longueur 2 car 25 (longueur du message) - 23 (le nombre de points sans erreur à partir de l'index donné)) dans la sous-liste de points : 0 à index donné (pas inclus) ;
   1. On crée une liste qui regroupe deux listes : la combinaison i et la sous-liste de points : de l'index donné jusqu'à la longueur de la liste de points (non inclus) ;
   2. On construit le polynôme de Lagrange avec la fonction `compute_lagrange_polynomial` ;
   3. On parcourt l'intégralité des points afin de vérifier si on a trouvé le bon polynôme ;
      1. On injecte x dans le polynôme et on regarde que le résultat soit égale à y, si le résultat est égal à y, on incrémente un compteur ;
   4. Si le compteur est >= m + n (m = longueur du message, n = nombre d'erreurs maximales), alors on a trouvé le seul et unique polynôme qui passe par tous les points du message originel ;
      1. Si le compteur est < m + n, on retourne au point 2 et on recommence avec une autre combinaison ;
2. On corrige le message avec le polynôme.

## Résultat

Message corrigé : Ce message vaut 18 points

Polynôme passant par tous les points du message : 229x²⁴ + 361x²³ + 51x²² + 312x²¹ + 36x²⁰ + 293x¹⁹ + 99x¹⁸ + 266x¹⁷ + 169x¹⁶ + 273x¹⁵ + 8x¹⁴ + 294x¹³ + 204x¹² + 35x¹¹ + 225x¹⁰ + 48x⁹ + 265x⁸ + 113x⁷ + 102x⁶ + 43x⁵ + 101x⁴ + 349x³ + 30x² + 138x + 67

